const Shell = imports.gi.Shell;
const St = imports.gi.St;
const Main = imports.ui.main;

let tray, box;

function on_tray_add(o, icon)
{
    let button = new St.Button({child:icon});

    button.connect('button-release-event', function(actor, event)
    {
        icon.click(event);
    });
    box.insert_child_at_index(button, box.get_n_children)
}

function on_tray_remove(o, icon)
{
    for (let button in box.get_children())
    {
        if (button.child === icon)
        {
            box.remove_child(button);
        }
    }
}

function init() {}

function enable()
{
    tray = new Shell.TrayManager();
    tray.connect('tray-icon-added', on_tray_add);
    tray.connect('tray-icon-removed', on_tray_remove);
    tray.manage_screen(Main.panel.actor);
    
    box = new St.BoxLayout();
    box.set_style('spacing: 13px; margin_top: 15px; margin_bottom: 12px;');

    Main.panel._rightBox.insert_child_at_index(box, 0);
}
function disable()
{
    box.destroy_all_children();
    Main.panel._rightBox.remove_child(box);
}
